summaryrefslogtreecommitdiff
path: root/resources/scripts/blobs
diff options
context:
space:
mode:
authorshmalebx9 <thonkpeasant@protonmail.com>2022-11-20 20:14:22 -0700
committershmalebx9 <thonkpeasant@protonmail.com>2022-11-26 12:56:31 -0700
commit175b48a4e0b0710434fb96f09250f126d6c6b30c (patch)
tree8469868caf7ddf13810014da6f3a8f832c418908 /resources/scripts/blobs
parentb2c71747cd883caf84b1e09667d902186a3138f7 (diff)
added more checks and optimised extraction script
Diffstat (limited to 'resources/scripts/blobs')
-rwxr-xr-xresources/scripts/blobs/download4
-rwxr-xr-xresources/scripts/blobs/extract35
2 files changed, 24 insertions, 15 deletions
diff --git a/resources/scripts/blobs/download b/resources/scripts/blobs/download
index b9471946..e8e82448 100755
--- a/resources/scripts/blobs/download
+++ b/resources/scripts/blobs/download
@@ -92,8 +92,8 @@ Build_deps(){
fi
if [ ! -f "coreboot/default/util/ifdtool/ifdtool" ]; then
- printf "building ifdtool from coreboot\n"
- ( cd coreboot/default/util/ifdtool && make ) || Fail 'could not build ifdtool'
+ printf "building ifdtool from coreboot\n"
+ make -C coreboot/default/util/ifdtool || Fail 'could not build ifdtool'
fi
}
diff --git a/resources/scripts/blobs/extract b/resources/scripts/blobs/extract
index cdb55cfe..b88741a7 100755
--- a/resources/scripts/blobs/extract
+++ b/resources/scripts/blobs/extract
@@ -13,10 +13,15 @@ Print_help(){
printf "\nYou need to specify exactly 2 arguments\n"
}
+Fail(){
+ printf "\nERROR: $@\n"
+ exit 1
+}
+
Build_deps(){
if [ ! -d me_cleaner ]; then
printf "downloading me_cleaner\n"
- ./download me_cleaner
+ ./download me_cleaner || Fail 'could not download me_cleaner'
else
printf "me_cleaner already downloaded. Skipping.\n"
printf "run ./download me_cleaner to manually overwrite\n"
@@ -24,19 +29,16 @@ Build_deps(){
if [ ! -d coreboot/default ]; then
printf "downloading coreboot\n"
- ./download coreboot default
+ ./download coreboot default || Fail 'could not download coreboot'
else
printf "coreboot already downloaded. Skipping.\n"
printf "run ./download coreboot to manually overwrite\n"
fi
- printf "building ifdtool from coreboot\n"
- ( cd coreboot/default/util/ifdtool && make )
-}
-
-Error_out(){
- printf "failed to extract ${1}\nmake sure that your rom dump is valid\n"
- exit 1
+ if ! [ -f coreboot/default/util/ifdtool/ifdtool ]; then
+ printf "building ifdtool from coreboot\n"
+ make -C coreboot/default/util/ifdtool || Fail 'could not build ifdtool'
+ fi
}
@@ -48,7 +50,7 @@ Extract_blobs(){
if [ "$CONFIG_HAVE_MRC" = "y" ]; then
printf 'haswell board detected, downloading mrc\n'
- ./download mrc
+ ./download mrc || Fail 'could not download mrc, check network connection'
fi
_me_destination=${CONFIG_ME_BIN_PATH#../../}
@@ -56,15 +58,22 @@ Extract_blobs(){
_ifd_destination=${CONFIG_IFD_BIN_PATH#../../}
printf "extracting clean ime and modified ifd\n"
- ./me_cleaner/me_cleaner.py -D ${_ifd_destination} -M ${_me_destination} ${vendor_rom} -t -r -S || Error_out me
+ ./me_cleaner/me_cleaner.py -D ${_ifd_destination} -M ${_me_destination} ${vendor_rom} -t -r -S \
+ || ./resources/blobs/me7_update_parser.py -O ${_me_destination} ${vendor_rom} \
+ || Fail 'me_cleaner failed to extract blobs from rom'
printf "extracting gigabit ethernet firmware"
./coreboot/default/util/ifdtool/ifdtool -x ${vendor_rom}
- mv flashregion*gbe.bin ${_gbe_destination} || Error_out gbe
+ mv flashregion*gbe.bin ${_gbe_destination} || Fail 'could not extract gbe'
# Cleans up other files extracted with ifdtool
rm flashregion*.bin 2> /dev/null
- printf "gbe, ifd, and me extracted to ${_me_destination%/*}\n"
+
+ if [ -f ${_ifd_destination} ]; then
+ printf "gbe, ifd, and me extracted to ${_me_destination%/*}\n"
+ else
+ printf "WARNING: Intel firmware descriptor could not be extracted with modified me\n"
+ fi
}
if [ ! -f "${vendor_rom}" ] ; then